# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::ComputerVision::V1_0
  module Models
    #
    # Result of AnalyzeImage operation.
    #
    class ImageAnalysis

      include MsRestAzure

      # @return [Array<Category>] An array indicating identified categories.
      attr_accessor :categories

      # @return [AdultInfo]
      attr_accessor :adult

      # @return [ColorInfo]
      attr_accessor :color

      # @return [ImageType]
      attr_accessor :image_type

      # @return [Array<ImageTag>] A list of tags with confidence level.
      attr_accessor :tags

      # @return [ImageDescriptionDetails]
      attr_accessor :description

      # @return [Array<FaceDescription>] An array of possible faces within the
      # image.
      attr_accessor :faces

      # @return [String] Id of the request for tracking purposes.
      attr_accessor :request_id

      # @return [ImageMetadata]
      attr_accessor :metadata


      #
      # Mapper for ImageAnalysis class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ImageAnalysis',
          type: {
            name: 'Composite',
            class_name: 'ImageAnalysis',
            model_properties: {
              categories: {
                client_side_validation: true,
                required: false,
                serialized_name: 'categories',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'CategoryElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Category'
                      }
                  }
                }
              },
              adult: {
                client_side_validation: true,
                required: false,
                serialized_name: 'adult',
                type: {
                  name: 'Composite',
                  class_name: 'AdultInfo'
                }
              },
              color: {
                client_side_validation: true,
                required: false,
                serialized_name: 'color',
                type: {
                  name: 'Composite',
                  class_name: 'ColorInfo'
                }
              },
              image_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'imageType',
                type: {
                  name: 'Composite',
                  class_name: 'ImageType'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ImageTagElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ImageTag'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'Composite',
                  class_name: 'ImageDescriptionDetails'
                }
              },
              faces: {
                client_side_validation: true,
                required: false,
                serialized_name: 'faces',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'FaceDescriptionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'FaceDescription'
                      }
                  }
                }
              },
              request_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'requestId',
                type: {
                  name: 'String'
                }
              },
              metadata: {
                client_side_validation: true,
                required: false,
                serialized_name: 'metadata',
                type: {
                  name: 'Composite',
                  class_name: 'ImageMetadata'
                }
              }
            }
          }
        }
      end
    end
  end
end
