# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::ComputerVision::V2_0
  module Models
    #
    # A region consists of multiple lines (e.g. a column of text in a
    # multi-column document).
    #
    class OcrRegion

      include MsRestAzure

      # @return [String] Bounding box of a recognized region. The four integers
      # represent the x-coordinate of the left edge, the y-coordinate of the
      # top edge, width, and height of the bounding box, in the coordinate
      # system of the input image, after it has been rotated around its center
      # according to the detected text angle (see textAngle property), with the
      # origin at the top-left corner, and the y-axis pointing down.
      attr_accessor :bounding_box

      # @return [Array<OcrLine>] An array of recognized lines of text.
      attr_accessor :lines


      #
      # Mapper for OcrRegion class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OcrRegion',
          type: {
            name: 'Composite',
            class_name: 'OcrRegion',
            model_properties: {
              bounding_box: {
                client_side_validation: true,
                required: false,
                serialized_name: 'boundingBox',
                type: {
                  name: 'String'
                }
              },
              lines: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lines',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'OcrLineElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'OcrLine'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
