# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::ComputerVision::V2_1
  module Models
    #
    # An object detected in an image.
    #
    class DetectedObject

      include MsRestAzure

      # @return [BoundingRect] Approximate location of the detected object.
      attr_accessor :rectangle

      # @return [String] Label for the object.
      attr_accessor :object

      # @return [Float] Confidence score of having observed the object in the
      # image, as a value ranging from 0 to 1.
      attr_accessor :confidence

      # @return [ObjectHierarchy] The parent object, from a taxonomy
      # perspective.
      # The parent object is a more generic form of this object.  For example,
      # a 'bulldog' would have a parent of 'dog'.
      attr_accessor :parent


      #
      # Mapper for DetectedObject class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DetectedObject',
          type: {
            name: 'Composite',
            class_name: 'DetectedObject',
            model_properties: {
              rectangle: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'rectangle',
                type: {
                  name: 'Composite',
                  class_name: 'BoundingRect'
                }
              },
              object: {
                client_side_validation: true,
                required: false,
                serialized_name: 'object',
                type: {
                  name: 'String'
                }
              },
              confidence: {
                client_side_validation: true,
                required: false,
                serialized_name: 'confidence',
                type: {
                  name: 'Double'
                }
              },
              parent: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parent',
                type: {
                  name: 'Composite',
                  class_name: 'ObjectHierarchy'
                }
              }
            }
          }
        }
      end
    end
  end
end
